<rtflowfile version="1.0">
   <block name="Average" folder="Standard\Dynamic\" width="64" height="48">
      <resize constrainprop="false" allow="true"/>
      <instancename show="true" position="up"/>
      <blockname show="false" position="down"/>
      <portnames show="true" inside="true"/>
      <graphic class="rect" x1="0" y1="0" x2="64" y2="48">
         <fill fill="true" color="0x00EEEEEE"/>
      </graphic>
      <doc>Computes the average of a real-valued signal over time. Values are only accumulated when enable is 1. Before any values have been accumulated, the resulting signal average will be 0. Notice that since the counter of accumulated cycles may be stored in a 32-bit signed integer, the resulting signal may be invalid after 2147483648 accumulated cycles.</doc>
      <port name="i" type="real" x="0" y="16" kind="input" dir="left">
         <doc>The value to compute the average of.</doc>
      </port>
      <port name="enable" type="bool" x="0" y="32" kind="input" dir="left">
         <doc>1 to accumulate i this cycle, 0 to ignore i this cycle.</doc>
      </port>
      <port name="average" type="real" x="64" y="16" kind="output" dir="right">
         <doc>The time average of i, or 0 if enable has not yet been 1.</doc>
      </port>
   </block>
   <schematic name="Average" width="903" height="602">
      <editor gridsize="16" alignports="true" autovalue="false"/>
      <binstance name="i" block="RealInput" x="80" y="64"/>
      <binstance name="enable" block="BoolInput" x="80" y="288"/>
      <binstance name="average" block="RealOutput" x="448" y="168"/>
      <binstance name="Add1" block="Add" x="240" y="96"/>
      <binstance name="Pre1" block="Pre" x="176" y="128">
         <constant name="initial" value="0" show="true" x="16" y="24"/>
      </binstance>
      <binstance name="Pre2" block="Pre" x="256" y="256">
         <constant name="initial" value="0" show="true" x="16" y="24"/>
      </binstance>
      <binstance name="Add2" block="Add" x="320" y="224"/>
      <binstance name="SafeDiv1" block="SafeDiv" x="384" y="160"/>
      <binstance name="If1" block="If" x="128" y="64"/>
      <binstance name="If2" block="If" x="208" y="192"/>
      <binstance name="Value1" block="Value" x="80" y="80">
         <constant name="value" value="0" show="true" x="16" y="8"/>
      </binstance>
      <binstance name="Value2" block="Value" x="160" y="208">
         <constant name="value" value="0" show="true" x="16" y="8"/>
      </binstance>
      <binstance name="Value3" block="Value" x="160" y="192">
         <constant name="value" value="1" show="true" x="16" y="8"/>
      </binstance>
      <connection name="average" port1="SafeDiv1.o" port2="average.i0">
         <point x="432" y="176"/>
         <point x="448" y="176"/>
      </connection>
      <connection name="Pre1_o_1" port1="Pre1.o" port2="Add1.i1">
         <point x="208" y="144"/>
         <point x="225" y="144"/>
         <point x="225" y="120"/>
         <point x="242" y="120"/>
      </connection>
      <connection name="If1_o_1" port1="If1.o" port2="Add1.i0">
         <point x="160" y="80"/>
         <point x="201" y="80"/>
         <point x="201" y="104"/>
         <point x="242" y="104"/>
      </connection>
      <connection name="Add1_o_1" port1="Add1.o" port2="Pre1.i0">
         <point x="272" y="112"/>
         <point x="288" y="112"/>
         <point x="288" y="176"/>
         <point x="160" y="176"/>
         <point x="160" y="144"/>
         <point x="176" y="144"/>
      </connection>
      <connection name="Add1_o_1" port1="Add1.o" port2="SafeDiv1.i0">
         <point x="272" y="112"/>
         <point x="288" y="112"/>
         <point x="288" y="176"/>
         <point x="384" y="176"/>
      </connection>
      <connection name="Pre2_o_1" port1="Pre2.o" port2="Add2.i1">
         <point x="288" y="272"/>
         <point x="305" y="272"/>
         <point x="305" y="248"/>
         <point x="322" y="248"/>
      </connection>
      <connection name="If2_o_1" port1="If2.o" port2="Add2.i0">
         <point x="240" y="208"/>
         <point x="281" y="208"/>
         <point x="281" y="232"/>
         <point x="322" y="232"/>
      </connection>
      <connection name="Add2_o_1" port1="Add2.o" port2="Pre2.i0">
         <point x="352" y="240"/>
         <point x="368" y="240"/>
         <point x="368" y="304"/>
         <point x="240" y="304"/>
         <point x="240" y="272"/>
         <point x="256" y="272"/>
      </connection>
      <connection name="enable" port1="enable.o" port2="If2.i2">
         <point x="96" y="296"/>
         <point x="216" y="296"/>
         <point x="216" y="224"/>
      </connection>
      <connection name="enable" port1="enable.o" port2="If1.i2">
         <point x="96" y="296"/>
         <point x="136" y="296"/>
         <point x="136" y="96"/>
      </connection>
      <connection name="i" port1="i.o" port2="If1.i1">
         <point x="96" y="72"/>
         <point x="128" y="72"/>
      </connection>
      <connection name="Add2_o_1" port1="Add2.o" port2="SafeDiv1.i1">
         <point x="352" y="240"/>
         <point x="368" y="240"/>
         <point x="368" y="192"/>
         <point x="384" y="192"/>
      </connection>
      <connection name="Value1_o_1" port1="Value1.o" port2="If1.i0">
         <point x="112" y="88"/>
         <point x="128" y="88"/>
      </connection>
      <connection name="Value2_o_1" port1="Value2.o" port2="If2.i0">
         <point x="192" y="216"/>
         <point x="208" y="216"/>
      </connection>
      <connection name="Value3_o_1" port1="Value3.o" port2="If2.i1">
         <point x="192" y="200"/>
         <point x="208" y="200"/>
      </connection>
   </schematic>
</rtflowfile>
